#include<iostream>
#include <vector>
#include<unordered_set>

#include<fstream>
#include<queue>

std::vector<std::vector<int>> adj;
std::vector<std::vector<int>> dp;

/* void bfs(int start) {
    std::vector<int> isVisited(adj.size()+1);

    std::queue<int> queue, queue1;

    queue.push(start);
    
    int level = 1;

    while(!queue.empty()) {
        int curr = queue.front();
        queue.pop();
        
        if(isVisited[curr]) 
            continue;

        isVisited[curr] = true;
        for(auto& k : adj[curr]) {
            if(isVisited[k])
                continue;
            //std::cout << start << " to " << k << " with " << level << std::endl;
            dp[start][k] = std::max(dp[start][k], level);
            queue1.push(k);
        }
        if(queue.empty()) {
            queue = queue1;
            queue1 = std::queue<int>();
            level++;
        }

        if(level > 3)
            return;
    }
    for(int i = 0; i < dp[start].size(); i++) {
       // std::cout << "From " << start << " to " << adj[start][i] << " dist: " << dp[start][i] << std::endl;
    }
} */

void dfs(int start, int curr, std::vector<bool> isVisited, int level) {
    if(level > 3) {
         return;
    }
    if(isVisited[curr])
        return;
    isVisited[curr] = true;
    for(auto& k : adj[curr]) {
        if(isVisited[k])
             continue;
        if(dp[start][k] != 2)
            dp[start][k] = level;
        //std::cout << str << k << std::endl;
        //std::cout << start << " to " << k << " dist: " << level << std::endl;
        dfs(start, k, isVisited, level+1);
    }
}

void callDfc(int start) {
    std::vector<bool> isVisited(adj.size());
    dfs(start, start, isVisited, 1);
}

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    adj.resize(N+1);
    dp.resize(N+1, std::vector<int>(N+1, -100000));

    const size_t size = friendships.size();
    for(int i = 0; i < size; i++) {
        adj[friendships[i].first].push_back(friendships[i].second);
        adj[friendships[i].second].push_back(friendships[i].first);
    }

    for(int i = 1; i < N; i++) {
        callDfc(friendships[i].first);
        callDfc(friendships[i].second);
    }
    return;
}

void connect(int ID, int x, int y)
{
    adj[x].push_back(y);
    adj[y].push_back(x);
    
    /* for(int i = 0; i < adj[x].size(); i++) {
        std::cout << x << " now has " << adj[x][i] << std::endl;
    } */

    for(int i = 1; i < adj.size(); i++) {
        callDfc(i);
    }
}

bool question(int ID, int x, int y)
{
    //std::cout << "Distance: " << dp[x][y] << std::endl;
    return (dp[x][y] == 2);
}

/* int main() {
    initialize(0, 5, 2, 1, {{1,2}, {1,3}, {2,4}, {3,4}, {4,5}});

    /* if(question(0, 2, 3)) {
        std::cout << "Yes\n";
    } else {
        std::cout << "No\n";
    }

    if(question(0, 4, 1))
        std::cout << "Yes\n";
    else
        std::cout << "No\n";

    if(question(0, 1, 5)) 
         std::cout << "Yes\n";
    else
        std::cout << "No\n";
    
    connect(0, 3, 5);

    if(question(0, 1, 5)) 
         std::cout << "Yes\n";
    else
        std::cout << "No\n";
    

    std::cout << "hello\n";
} */