#include <iostream>
#include <vector>
using namespace std;
const int MAXN=1e5+10;
struct Query {
    int x, y, type;
};
Query mem[MAXN];
vector <int> v[MAXN];
int p[MAXN], d[MAXN], lev[MAXN], top[MAXN];
bool used[MAXN];
int get_root(int x) {
    if (p[x]==x) return x;
    return p[x]=get_root(p[x]);
}
void add_edge(int a, int b) {
    int ra, rb;
    ra=get_root(a);
    rb=get_root(b);
    if (ra==rb) return;
    if (d[ra]==d[rb]) {
        d[ra]++;
        p[rb]=ra;
    } else if (d[ra]>d[rb]) p[rb]=ra;
    else p[ra]=rb;
}
void dfs(int x) {
    used[x]=true;
    for (auto i:v[x]) {
        lev[i]=lev[x]+1;
        dfs(i);
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> q;
    int cnt=1, x, a;
    char ch;
    for (int t=0;t<q;t++) {
        cin >> ch >> x;
        mem[t].x=x;
        if (ch=='?') {
            mem[t].type=1;
            mem[t].y=top[get_root(x)];
        }
        else {
            mem[t].type=0;
            mem[t].x=cnt;
            p[cnt]=cnt;
            d[cnt]=1;
            for (int i=0;i<x;i++) {
                cin >> a;
                add_edge(cnt,a);
                v[cnt].push_back(a);
            }
            top[get_root(cnt)]=cnt;
            cnt++;
        }
    }
    for (int i=cnt;i>=1;i--) {
        if (!used[i]) {
            lev[i]=1;
            dfs(i);
        }
    }
    for (int i=0;i<q;i++) {
        if (mem[i].type) {
            cout << (lev[mem[i].x]-lev[mem[i].y]+1)%2;
            ///cout << lev[mem[i].x]-lev[mem[i].y] << ' ' << lev[mem[i].y] << ' ' << lev[mem[i].x] << ' ' << mem[i].x << ' ' << mem[i].y << endl;
        }
    }
    cout << endl;
    return 0;
}
