#include <iostream>
#include <utility>
#include <vector>
#include <unordered_set>

using namespace std;

const int MAXN = 1e5 + 3;
unordered_set<int> graph[MAXN];

void initialize(int ID, int N, int M, int Q, vector<pair<int,int>> friendships) {
    for (auto [x, y] : friendships) {
        --x;
        --y;

        graph[x].insert(y);
        graph[y].insert(x);
    }
}

void connect(int ID, int x, int y) {
    --x;
    --y;

    graph[x].insert(y);
    graph[y].insert(x);
}

bool question(int ID, int x, int y) {
    --x;
    --y;

    if ((int) graph[x].size() > (int) graph[y].size()) {
        swap(x, y);
    }

    for (int neighbor : graph[x]) {
        if (graph[neighbor].count(y)) {
            return true;
        }
    }

    return false;
}

