#include <iostream>
#include <vector>

#define endl '\n'

using namespace std;

const int MAXN = 1e6 + 3;

int next_document[MAXN], depth[MAXN];
bool is_one_origin[MAXN];

bool is_active(int target) {
    int counter = 0;

    while (next_document[target] != -1) {
        ++counter;
        target = next_document[target];
    }

    return counter % 2 == 0;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;

    int curr_document = 1;

    int max_one_chain = 0;
    is_one_origin[1] = true;

    for (int i = 0; i < q; ++i) {
        char type;
        cin >> type;

        if (type == '?') {
            int target;
            cin >> target;

            cout << (max_one_chain % 2 == 0);

            continue;
        }

        int n;
        cin >> n;

        for (int j = 0; j < n; ++j) {
            int x;
            cin >> x;

            next_document[x] = curr_document;

            if (is_one_origin[x]) {
                ++max_one_chain;
                is_one_origin[curr_document] = true;
            }
        }

        next_document[curr_document] = -1;
        ++curr_document;
    }

    cout << endl;
}
