#include <iostream>
#include <vector>

#define endl '\n'

using namespace std;

const int MAXN = 1e6 + 3;

int next_document[MAXN], depth[MAXN];
int last_seen[MAXN];

bool is_active(int target) {
    int curr_document = target;
    int counter = 0;

    while (last_seen[curr_document] != curr_document) {
        counter += depth[curr_document];
        curr_document = last_seen[curr_document];
    }

    while (next_document[curr_document] != -1) {
        ++counter;
        curr_document = next_document[curr_document];
    }

    last_seen[target] = curr_document;
    depth[target] = counter;

    return counter % 2 == 0;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;

    int curr_document = 1;

    for (int i = 0; i < MAXN; ++i) {
        last_seen[i] = i;
        depth[i] = 0;
    }

    for (int i = 0; i < q; ++i) {
        char type;
        cin >> type;

        if (type == '?') {
            int target;
            cin >> target;

            cout << is_active(target);

            continue;
        }

        int n;
        cin >> n;

        for (int j = 0; j < n; ++j) {
            int x;
            cin >> x;

            next_document[x] = curr_document;
        }

        next_document[curr_document] = -1;
        ++curr_document;
    }

    cout << endl;
}
