#include <iostream>
#include <vector>
#include <utility>
#include <queue>
#include <algorithm>

#define endl '\n'

using namespace std;

const int MAXN = 5e5 + 3;
const int INF = 1e9;

vector<pair<int, int>> graph[MAXN], reverse_graph[MAXN];
int dist[MAXN], parent[MAXN];
bool in_queue[MAXN];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    for (int i = 0; i < MAXN; ++i) {
        dist[i] = INF;
        parent[i] = -1;
    }

    int n, m;
    cin >> n >> m;

    vector<int> paths[2];

    for (int i = 0; i < m; ++i) {
        int from, to;
        cin >> from >> to;

        --from;
        --to;

        if (from == 0 and to == n - 1) {
            paths[1].push_back(i + 1);
            continue;
        }

        graph[from].push_back({to, i});
        reverse_graph[to].push_back({from, i});
    }

    queue<int> spfa;

    spfa.push(0);
    in_queue[0] = true;

    dist[0] = 0;
    parent[0] = -1;

    while (!spfa.empty()) {
        int currv = spfa.front();
        spfa.pop();

        for (auto [nextv, i] : graph[currv]) {
            if (dist[currv] + 1 >= dist[nextv]) {
                continue;
            }

            dist[nextv] = dist[currv] + 1;
            parent[nextv] = currv;

            if (!in_queue[nextv]) {
                spfa.push(nextv);
                in_queue[nextv] = true;
            }
        }
    }

    int currv = n - 1;

    while (parent[currv] != -1) {
        int counter = 0;

        for (auto [nextv, i] : reverse_graph[currv]) {
            if (nextv != parent[currv]) {
                continue;
            }

            if (counter < 1) {
                paths[counter++].push_back(i + 1);
            }
        }

        currv = parent[currv];
    }

    cout << (int) paths[0].size() << " " << (int) paths[1].size()  << endl;

    for (int i = 0; i < 2; ++i) {
        reverse(paths[i].begin(), paths[i].end());

        for (int res : paths[i]) {
            cout << res << " ";
        }
        cout << endl;
    }

    return 0;
}
