#include <iostream>
#include <vector>
#include <utility>
#include <queue>
#include <algorithm>

#define endl '\n'

using namespace std;

const int MAXN = 5e5 + 3;
const int INF = 1e9;

vector<pair<int, int>> graph[MAXN], reverse_graph[MAXN];
bool used_edge[MAXN];

int n, res;
vector<int> curr_paths[2], res_paths[2];

void find_paths(int path_ind, int currv) {
    if (currv == n - 1) {
        if (path_ind == 0) {
            find_paths(1, 0);
            return;
        }

        int path1 = (int) curr_paths[0].size();
        int path2 = (int) curr_paths[1].size();

        if (path1 + path2 < res) {
            res = path1 + path2;
            res_paths[0] = curr_paths[0];
            res_paths[1] = curr_paths[1];
        }

        return;
    }

    for (auto [nextv, i] : graph[currv]) {
        if (used_edge[i]) {
            continue;
        }

        used_edge[i] = true;
        curr_paths[path_ind].push_back(i + 1);

        find_paths(path_ind, nextv);

        used_edge[i] = false;
        curr_paths[path_ind].pop_back();
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int m;
    cin >> n >> m;

    for (int i = 0; i < m; ++i) {
        int from, to;
        cin >> from >> to;

        --from;
        --to;

        graph[from].push_back({to, i});
    }

    res = 3 * m;
    find_paths(0, 0);

    cout << (int) res_paths[0].size() << " " << (int) res_paths[1].size()  << endl;

    for (int i = 0; i < 2; ++i) {
        for (int res : res_paths[i]) {
            cout << res << " ";
        }
        cout << endl;
    }

    return 0;
}
