#include <vector>

std::vector<int> components;
int compOf(int index)
{
    if(index==components[index])
    {
        return index;
    }
    return components[index]=compOf(components[index]);
}

void conn (int a, int b)
{
    components[compOf(b)]=compOf(a);
}

bool connected(int x, int y)
{
    if(compOf(x)==compOf(y))
    {
        return true;
    }
    return false;
}

void initialize(int ID, int N, int M, int Q, std::vector < std::pair < int, int > > friendships)
{
    for(int i=0; i<=N; i++)
    {
        components[i]=i;
    }
    for(int i=0; i<M; i++)
    {
        conn(friendships[i].first, friendships[i].second);
    }
}

void connect(int ID, int x, int y)
{
    conn(x, y);
}

bool question(int ID, int x, int y)
{
    return connected(x, y);
}
